=== tools/CMakeLists.txt ===
ADD_SUBDIRECTORY( tcpClient )
ADD_SUBDIRECTORY( tcpImagesServer )
ADD_SUBDIRECTORY( tcpRequest )
ADD_SUBDIRECTORY( tcpService )
IF(NONFREE)
ADD_SUBDIRECTORY( similarity )
ENDIF(NONFREE)
