=== debian/changelog ===
ros-iron-find-object-2d (0.7.0-5jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Thu, 20 Apr 2023 04:46:15 -0000
